/**
 *
 * Copyright (C) 2000 Vandoorselaere Yoann, Thomas Mirlacher
 * All Rights Reserved
 *
 * This file is part of the OMS program.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

#include <stdio.h>
#include <stdlib.h>

#include "xmlparse.h"
#include "xmltag_widget.h"


static void dump_tree (oms_xmltree_t *entry) 
{
        for (; entry; entry=entry->next) {
        	oms_xmltree_node_t *data = (oms_xmltree_node_t *) entry->data;

                printf("%d:\t%s=%s\n\t%s\n\n",
			data->type_val,
                	data->var_name,
                	data->var_val,
			data->text);
        }
}        


int main (void)
{
        const char file[] = "test.xml";
	oms_xmltree_t *oms_tree;

	if (oms_xml_init (xmltag_widget_init ()) < 0) {
                fprintf (stderr, "There was an error at initialization time.\n");
                exit (-1);
        }

        if (!(oms_tree = oms_xml_parse_file (file)) < 0) {
                fprintf (stderr, "There was an error parsing file %s.\n", file);
                exit (-1);
        }

        printf ("Dumping XML tree :\n");
        dump_tree (oms_tree);

	return 0;
}
