/*****
*
* This file is part of the OMS program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <inttypes.h>

struct Rtp_Header {
#if BYTE_ORDER == LITTLE_ENDIAN
	uint8_t csrc_count	:4;	// CSRC count
	uint8_t extension	:1;	// header extension flag
	uint8_t padding		:1;	// padding flag
	uint8_t version		:2;	// protocol version
	uint8_t payload_type	:7;	// payload type
	uint8_t marker		:1;	// marker bit
#elif BYTE_ORDER == BIG_ENDIAN
	uint8_t version		:2;	// protocol version
	uint8_t padding		:1;	// padding flag
	uint8_t extension	:1;	// header extension flag
	uint8_t csrc_count	:4;	// CSRC count
	uint8_t marker		:1;	// marker bit
	uint8_t payload_type	:7;	// payload type
#endif
	uint16_t seq;			// sequence number
	uint32_t timestamp;		// timestamp
	uint32_t ssrc;			// synchronization source
	uint32_t csrc[1];		// optional CSRC list
}
