#!/usr/bin/perl

$filename = shift;
$replace = shift;

my $fileref = "";
my $type = "include";
my $in_comment = 0;

sub handle_comments
{
        if ($in_comment == 1) {			# already in comment
                if (/\*\//) {			# end of comment
                        $in_comment = 0;
                }
        } elsif (/\/\*\ /) {			# normal comment -> skip
                $in_comment = 1;
        } elsif (/\/\*$/) {			# normal comment -> skip
                $in_comment = 1;
        } elsif (/^\ *\/\//) {			# normal comment -> skip
#        	return "";
		return $_;
        } else {
                return $_;
        }

        return "";
}


sub handle_sgml
{
	s/\</&lt;/g;
	s/\>/&gt;/g;
	s/\t/\ \ \ \ \ \ \ \ /g;
}


sub handle_cpp
{
	if (/^\ *#/) {
		$_ = "";
	}
}


open (FD, "<$filename");

foreach (<FD>) {
	if (/<!--\w*(.*)\w*-->/) {	# found the special tag
		$entries = $1;
		@tags=split (' ', $entries);

		foreach (@tags) {	# parse tags
			eval ("\$".$_);
		}


		if ($type == 'include') {
			print "<programlisting>";
			open (FD1, "<$fileref");
			foreach (<FD1>) {
				handle_sgml ($_);
				handle_cpp ($_);
				print handle_comments ($_);
			}
			close (FD1);
			print "</programlisting>";
		} else {
			print "UNHANDLED TMPL TYPE";
		}
	} else {
		s/\.fig/\.$replace/;
		print $_;
	}
}


close (FD);
