
/*
 *
 * Copyright (C) 1999-2000  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as <dent@linuxvideo.org>
 *
 *------------------------------------------------------------
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#ifdef DEVEL
#include <fcntl.h>
#endif

#include <oms/oms.h>
#include <oms/buf.h>
#include <oms/plugin.h>
#include <oms/plugin/codec.h>


int demux_set_status (uint status)
{
	if ((status == STATUS_PAUSE) && (demux.status == STATUS_STOP))
		return -1;

	switch (status) {
	case STATUS_PLAY:
		if (demux.status == STATUS_PAUSE) {
//			PLUGIN_OPS_CODEC_VIDEO(plugin_list, set_status, STATUS_PLAY);
//			PLUGIN_OPS_CODEC_AUDIO(plugin_list, set_status, STATUS_PLAY);
		} else {
//			PLUGIN_OPS_CODEC_VIDEO(plugin_list, set_status, STATUS_PLAY);
//			PLUGIN_OPS_CODEC_AUDIO(plugin_list, set_status, STATUS_PLAY);
			LOG (LOG_DEBUG, "THREAD CREATED");
		}	

		break;
	case STATUS_PAUSE:
//		PLUGIN_OPS_CODEC_VIDEO(plugin_list, set_status, STATUS_PAUSE);
//		PLUGIN_OPS_CODEC_AUDIO(plugin_list, set_status, STATUS_PAUSE);
		break;
	case STATUS_STOP:
//		PLUGIN_OPS_CODEC_VIDEO(plugin_list, set_status, STATUS_STOP);
//		PLUGIN_OPS_CODEC_AUDIO(plugin_list, set_status, STATUS_STOP);

//		pthread_join (demux.loop, NULL);

		if (demux.status == STATUS_PAUSE) {
			demux.status = STATUS_STOP;
		}


		pthread_join (demux.loop, NULL);
		LOG (LOG_DEBUG, "THREAD JOINED demux.c:demux_set_status");

		break;
	case STATUS_FINISH:
		demux.status = STATUS_FINISH;
		break;

	default:
		LOG (LOG_WARNING, "demux_set_status: unhandled status %d", status);
		return -1;
	}

	demux.status = status;

	return 0;
}
