
/*
 * OVERLAY A SUBPICTURE OVER ANOTHER IMAGE (USING 4BytePerPixel)
 *
 * Copyright (C) 2000  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#include <stdio.h>
#include <sys/types.h>

#include "spu.h"

/**
 *
 */

u_int *overlay (u_int *img1, struct spu_img_struct *spu, float o1)
{
	u_int x, y;
	u_char *clr_ptr1 = (u_char *) img1;
	u_char *clr_ptr2;
	u_char *spu_data_ptr = (u_char *) spu->data;
	float o;

// don't know why this can happen - but it does happen
	if ((spu->width <= 0) || (spu->height <= 0) ||
	    (spu->width > 1024) || (spu->height > 1024)) {
		fprintf (stderr, "width || height out of range.\n");
		return NULL;
	}

	for (y = spu->y; y < (spu->height + spu->y); y++) {
		clr_ptr1 = (u_char *) (img1 + y * 720 + spu->x);
		for (x = spu->x; x < (spu->width + spu->x); x++) {
			o = ((float) (*spu_data_ptr>>4) / 15.0) * o1;
			clr_ptr2 = (u_char *) &spu_clut[*spu_data_ptr&0x0f];
			spu_data_ptr ++;

			*clr_ptr1++ = (1-o)*(*clr_ptr1) + o*(*clr_ptr2++);
			*clr_ptr1++ = (1-o)*(*clr_ptr1) + o*(*clr_ptr2++);
			*clr_ptr1++ = (1-o)*(*clr_ptr1) + o*(*clr_ptr2++);
			*clr_ptr1++ = (1-o)*(*clr_ptr1) + o*(*clr_ptr2++);
		}
	}

	return img1;
}

