/*****
*
* This file is part of the OMS program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <oms/plugin/decaps.h>

#include <bswap.h>
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "bytestream.h"

uint8_t *block_read;
uint8_t *block_start;
uint8_t *block_end;

uint8_t block[65000];

uint8_t *bytestream_get_block (plugin_decaps_t * decaps)
{
	fprintf (stderr, "get_block %d\n", decaps->blocksize);
	if (decaps->read (NULL, block, decaps->blocksize) <= 0);
	//return NULL;
	fprintf (stderr, "get_block2 %d\n", decaps->blocksize);

	return block;
}

uint8_t *bytestream_get_bh (plugin_decaps_t * decaps, int num_bytes)
{
	uint8_t *ptr;

	fprintf (stderr, "get_bh\n");
// save old stuff
	ptr = bytestream_get_block (decaps);

	{
		int i;

		if (ptr)
			for (i = 0; i < 100; i++)
				fprintf (stderr, "%02x ", ptr[i]);
		else
			fprintf (stderr, "NO PTR\n");
	}

	block_read = ptr;
	block_start = ptr;
	block_end = ptr + decaps->blocksize;

	return ptr;
}

void bytestream_init (void)
{
	block_read = NULL;
	block_start = NULL;
	block_end = NULL;
}

int _bytes_left (void)
{
}

uint8_t *bytestream_get (plugin_decaps_t * decaps, int num_bytes)
{
	if (num_bytes > _bytes_left ()) {
	}
	fprintf (stderr, "bytestream_get: %d\n", num_bytes);

	do {
		if (block_read) {	// we do have a buffer
			if (num_bytes < 0) {
				if ((block_read + num_bytes) >= block_start) {	// since num_bytes is negative
					block_read += num_bytes;
					return block_read;
				} else {
					fprintf (stderr,
						 "%s:%s:%d unable to rewind %d bytes\n",
						 __FILE__, __FUNCTION__,
						 __LINE__, -num_bytes);
					return NULL;
				}
			} else if (num_bytes > 0) {
				if (
				    (num_bytes <=
				     (block_end - block_read))) {
					uint8_t *ptr = block_read;

					block_read += num_bytes;

					return ptr;
				} else
					fprintf (stderr,
						 "UNALGNED read !!!\n");
			} else {	// num_bytes == 0
				return block_read;
			}
		}
	} while (block_read = NULL, bytestream_get_bh (decaps, num_bytes));

	return NULL;
}
